﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

///
///多层神经网络源代码，版权所有 2016 张磊
///有关于此程序代码的详细说明，
///参见 http://www.qiantec.cn/post/wb1
///
namespace NNR
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();
            p.Start();           
        }

        private void Start()
        {
            DateTime dtStart = DateTime.Now;
            System.Console.WriteLine("加载文件id对照表");
            InitFileList();
            System.Console.WriteLine("加载五层神经网络权值数据");
            NN n = NN.Load("d:\\test.bin");
            System.Console.WriteLine("加载文本汉字字频数据");
            var txtline = System.IO.File.ReadAllLines("d:\\data.txt");
            System.Console.WriteLine("开始分类");
            int total = 0;
            int suc = 0;
            int failed = 0;
            int id = 0;
            foreach (var line in txtline)
            {
                if (line.Trim() == "")
                    continue;
                var subline = line.Split(' ');
                double[] data = new double[1024];
                for (int i = 0; i < 1024; i++)
                    data[i] = double.Parse(subline[i + 1].Substring(subline[i + 1].IndexOf(':') + 1));
                var wanted = double.Parse(subline[0]);
                total++;
                var res = n.Run(data);
                if (Math.Abs(res - wanted) > 0.4)
                {
                    failed++;
                    System.Console.WriteLine("分类错误 " + id + " 期望值 " + wanted + " 运算值 " + res.ToString("f4") + " 文件 " + dsfile[id]);
                }
                else
                    suc++;
                id++;
            }
            System.Console.WriteLine("分类完成，耗时" + (DateTime.Now - dtStart) + " 准确率:");
            System.Console.WriteLine(suc + " / " + total + " = " + (suc * 100.0 / total).ToString("f2") + "% 错误数 " + failed);
            System.Console.WriteLine("按回车键退出");
            System.Console.ReadLine();
        }
        System.Collections.Generic.Dictionary<int, string> dsfile;
        void InitFileList()
        {
            dsfile = new Dictionary<int, string>();
            int idfile = 0;
            foreach (var dir in System.IO.Directory.GetDirectories(@"d:\ClassFile"))
            {
                System.Console.WriteLine("load " + dir);
                foreach (var file in System.IO.Directory.GetFiles(dir))
                {
                    if (file.ToLower() == @"d:\classfile\c000007\0.txt")
                        continue;
                    dsfile[idfile] = file;
                    idfile++;
                }
            }
        }
    }
}
